<?php

namespace app\components\modules\payment;
use framework\request\Request;

class bitpay extends Payment
{
	public function request($id, $au, $price, $module, $product)
	{
		$api		= $module['api']['value'];
		$amount	 = $this->getRial($price);
		$redirect   = urlencode($this->getCallbackUrl($au));
		$factorId   = $id;
		
		$ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,'http://bitpay.ir/payment/gateway-send');
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect&factorId=$factorId");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
		
		
		if($res > 0 && is_numeric($res))
		{
			$this->updateAu($id, $res);
			$this->redirect("https://bitpay.ir/payment/gateway-$res");
		} 
		else
		{
			$this->setFlash('danger', 'خطا در اتصال به درگاه - '.$res);
			return false;
		}
		
	}

	public function verify($id, $au, $price, $module, $product)
	{
		if (isset($_POST['id_get']) && isset($_POST['trans_id']))
		{
			$api		= $module['api']['value'];
			$id_get 	 = $_POST['id_get'];
			$trans_id   = $_POST['trans_id'];
			
			
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,'http://bitpay.ir/payment/gateway-result-second');
			curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
			
			
			
			if($res == 1)
			{
				return array('au' => $trans_id);
			}
			else
			{
				$this->setFlash('danger', 'خطا در تایید تراکنش - '.$res);
				return false;
			}
			
		}
		else
		{
			$this->setFlash('danger', 'پرداخت لغو شد');
			return false;
		}
	}

	public function fields()
	{
		return array('api' => array('label' => 'Api key', 'value' => ''));
	}
}

?>